#include "d:\scilab-4.0\routines\stack-c.h"
void bet __PARAMS((int *a, int m, int n,int *b, int *nodenum,double *bt));

int intbet(fname) 
     char *fname;
{
  static int l1, m1, n1, l2,m2,l3,l4;
  static int minlhs=0, maxlhs=1, minrhs=3, maxrhs=3;   //why the minlhs must equal zero??
  static int tmp1,tmp2,tmp3;
  static int m3,n3,m4,n4;

  CheckRhs(minrhs,maxrhs) ;
  CheckLhs(minlhs,maxlhs) ;

  GetRhsVar(1, "i", &m1, &n1, &l1);   //the following sentence must be wrote together!!!! 
  GetRhsVar(2, "i", &m1, &n1, &l2);
  GetRhsVar(3, "i", &m1, &m1, &l3);
  m2=*istk(l3);
  CreateVar(4, "d", &m1, &m2, &l4);  
  bet(istk(l1), m1, n1,istk(l2), istk(l3),stk(l4));
  /*  Return C (3)  */
  LhsVar(1) = 4;
  return 0;
}

#include <stdio.h>
#include <stdlib.h>

int s;    // The source
int fur;  // The maximal distance from the source
int **d;  // The array d[h] denotes the set of nodes with distance h from the source
int **g;  // Graph
double *bn; // The node betweenness
double *tn; // The node betweenness for a certain source 
double *w;  // The weight of node 
int *dis;  // The distance from the source
int *que;  // The queue for breadth-first search
int *temp; // The temp queue for breadth-first search
int *deg;


void input(int *head,int *tail,int edge,int N)
{
	int aa,bb;
	int i,j;
	int e=0;
	for(i=0;i<N;i++)
	{
		deg[i]=0;
		for(j=0;j<2000;j++)
		{
			g[i][j]=0;
		}
	}
	while(e<edge)
	{
		aa=head[e]-1;
		bb=tail[e]-1;
		g[aa][deg[aa]]=bb;
		g[bb][deg[bb]]=aa;
		sciprint("%i %i\n",g[aa][deg[aa]],g[bb][deg[bb]]);
		e++;
	}
}


void Get_Dis(int N) 
{
	
	int i,j,k,step;
    for (i=0;i<N;i++)
	{
		dis[i]=-1;
		d[i][0]=0;
	}

    dis[s]=0;
	que[0]=1;
	que[1]=s;
	d[0][0]=1;
	d[0][1]=s;
	k=N-1;
	step=0;

   while (k>0)
	{
		temp[0]=0;
		step++;
		for (i=1;i<=que[0];i++)
		{
			for (j=1;j<=g[que[i]][0];j++)
				if (dis[g[que[i]][j]]==-1)
				{
					dis[g[que[i]][j]]=step;
					k--;
					temp[0]++;
					temp[temp[0]]=g[que[i]][j];
				}
		}
		for (i=0;i<=temp[0];i++)
		{
			que[i]=temp[i];
			d[step][i]=temp[i];
		}
	}
	fur=step;
	sciprint("fur=%i \n",fur);	
	return;
}

void Get_Weight(int N)
{
	int i,j,k,l;
	for (i=0;i<N;i++)
		w[i]=0.0;
	w[s]=1.0;
	for (k=1;k<=fur;k++)
	{
		for (i=1;i<=d[k][0];i++)
		{
			j=d[k][i];
			for (l=1;l<=g[j][0];l++)
			{
				if (dis[g[j][l]]==k-1)
					w[j]+=w[g[j][l]];
			}
		}
	}
	return;
}


void Get_Bnode(int N)
{
	int i,j,k,l;
	double add;
	for (i=0;i<N;i++)
		tn[i]=1.0;
	Get_Weight(N);
	for (k=fur;k>1;k--)
	{
		for (i=1;i<=d[k][0];i++)
		{
			j=d[k][i];

			for (l=1;l<=g[j][0];l++)
			{
				if (dis[g[j][l]]==k-1)
				{
					if(w[j]!=0)
					{
	    				add=tn[j]*w[g[j][l]]/w[j];
		    			tn[g[j][l]]+=add;
//						sciprint("add=%e \n",add);
					}
				}
	
			}


		}
	}
	for (i=0;i<N;i++)
		bn[i]+=tn[i];
	bn[s]-=1.0;
	return;
}

void freeall()
{
	free(d);
	free(temp);
	free(dis);
	free(que);
	free(bn);
	free(tn);
	free(w);
	free(g);
	free(deg);
}

//#define A(i,k) a[i+(*n)*k]

//void bet __PARAMS((int *a, int m, int n,int *b, int *nodenum,double *b));

void bet(a,m,n,b,nodenum,bt)
int a[],b[],nodenum[];
double bt[];
int m,n;
{
	
	int i;
	int N;
	N=*(nodenum);
    /////////////////////////////////////////////////
	d=malloc(N*sizeof(int *));
	for(i=0;i<N;i++)
		d[i]=malloc(2000*sizeof(int));   //generate d[N][2000]
	////////////////////////////////////////////////////

	/////////////////////////////////////////////////
	g=malloc(N*sizeof(int *));
	for(i=0;i<N;i++)
		g[i]=malloc(2000*sizeof(int));   //generate g[N][2000]
	////////////////////////////////////////////////////
    
	dis=(int *) malloc(N * sizeof(int));
	temp=(int *) malloc(N * sizeof(int));
	que=(int *) malloc(N * sizeof(int));
	bn=(double *)malloc(N * sizeof(double));
	tn=(double *)malloc(N * sizeof(double));
	w=(double *)malloc(N * sizeof(double));
	deg=(int *) malloc(N * sizeof(int));
  
     input(a,b,n,N);	
	
  
	for (i=0;i<N;i++)
	   bn[i]=0.0;

Get_Dis(N);
	
	
	
	for (s=0;s<N;s++)
	{
		if (s%100==0)
			sciprint("%i\t",s);
//		Get_Dis();
//		Get_Bnode();
	
	}

	
	
/*	for (i=0;i<N;i++)
	{
	      bt[i]=bn[i];
	      sciprint("%i %d \n",g[i][0],bn[i]);
	}
*/	
	freeall();


}