#include <stdio.h>
#include <stdlib.h>

//#define N 2080
#define N 100

FILE *fp;
FILE *fnode;

int g[N][600];   // Graph
/*
int m;   // The number of edges
int s;   // The source
int fur;   // The maximal distance from the source
int g[N][600];   // Graph
int d[N][500];   // The array d[h] denotes the set of nodes with distance h from the source

double bn[N];   // The node betweenness

double tn[N];   // The node betweenness for a certain source 

double w[N];    // The weight of node    
int dis[N];   // The distance from the source
int que[N];   // The queue for breadth-first search
int temp[N];   // The temp queue for breadth-first search
*/

int *m;
int *s;
int *fur;
int **d;
double *bn;
double *tn;
double *w;
int *dis;
int *que;
int *temp;


void Read_Graph()
{
	int i,j;
	m=0;
	fp=fopen("edge_ba,z=16,10000.txt","r");
	for (i=0;i<N;i++)
		g[i][0]=0;
	while (fscanf(fp,"%d %d",&i,&j)==2)
	{
//		i--;
//		j--;
		g[i][0]++;
		g[i][g[i][0]]=j;
		g[j][0]++;
		g[j][g[j][0]]=i;
		m++;
	
	}

    fclose(fp);

    for (i=0;i<N;i++)
	{
		bn[i]=0.0;

	}
	return;
}

void Get_Dis()
{
	int i,j,k,step;
	for (i=0;i<N;i++)
	{
		dis[i]=-1;
		d[i][0]=0;
	}

    dis[s]=0;
	que[0]=1;
	que[1]=s;
	d[0][0]=1;
	d[0][1]=s;
	k=N-1;
	step=0;

   while (k>0)
	{
		temp[0]=0;
		step++;
		for (i=1;i<=que[0];i++)
		{
			for (j=1;j<=g[que[i]][0];j++)
				if (dis[g[que[i]][j]]==-1)
				{
					dis[g[que[i]][j]]=step;
					k--;
					temp[0]++;
					temp[temp[0]]=g[que[i]][j];
				}
		}
		for (i=0;i<=temp[0];i++)
		{
			que[i]=temp[i];
			d[step][i]=temp[i];
		}
	}
	fur=step;
	return;
}

void Get_Weight()
{
	int i,j,k,l;
	for (i=0;i<N;i++)
		w[i]=0.0;
	w[s]=1.0;
	for (k=1;k<=fur;k++)
	{
		for (i=1;i<=d[k][0];i++)
		{
			j=d[k][i];
			for (l=1;l<=g[j][0];l++)
			{
				if (dis[g[j][l]]==k-1)
					w[j]+=w[g[j][l]];
			}
		}
	}
	return;
}


void Get_Bnode()
{
	int i,j,k,l;
	double add;
	for (i=0;i<N;i++)
		tn[i]=1.0;
	Get_Weight();
	for (k=fur;k>1;k--)
	{
		for (i=1;i<=d[k][0];i++)
		{
			j=d[k][i];

			for (l=1;l<=g[j][0];l++)
			{
				if (dis[g[j][l]]==k-1)
				{
					if(w[j]!=0)
					{
	    				add=tn[j]*w[g[j][l]]/w[j];
		    			tn[g[j][l]]+=add;
					}
				}
	
			}


		}
	}
	for (i=0;i<N;i++)
		bn[i]+=tn[i];
	bn[s]-=1.0;
	return;
}




void Output()
{
	int i;
	
	
    
    
    
    
    fnode=fopen("be_9new.txt","w");

	for (i=0;i<N;i++)
		fprintf(fnode,"%d           %lf\n",g[i][0],bn[i]);

	fclose(fnode);

	return;
}

int main()
{
	int node_num=N;
        /////////////////////////////////////////////////
	d=malloc(node_num*sizeof(int *));
	for(i=0;i<node_num;i++)
		d[i]=malloc(600*sizeof(int));   //d[N][600] 
	////////////////////////////////////////////////////

	/////////////////////////////////////////////////
	g=malloc(node_num*sizeof(int *));
	for(i=0;i<node_num;i++)
		g[i]=malloc(600*sizeof(int));   //g[N][600] 
	////////////////////////////////////////////////////
    
	dis=(int *) malloc(node_num * sizeof(int));
	temp=(int *) malloc(node_num * sizeof(int));
	que=(int *) malloc(node_num * sizeof(int));
	bn=(double *)malloc(node_num * sizeof(double));
	tn=(double *)malloc(node_num * sizeof(double));
	w=(double *)malloc(node_num* sizeof(double));
    
    
    
    
    
    Read_Graph();
	for (s=0;s<N;s++)
	{
		if (s%1==0)
			printf("%d\t",s);
		Get_Dis();
		Get_Bnode();
	
	}
	Output();
	getchar();
	return(1);
}
