#include  <math.h>
#include  <stdio.h>
#include  <stdlib.h>
#include  <time.h>

#define   N    10000
#define   T    2000
#define   P    1
#define   AG   1
#define N0 10

int      node[N][500];
int      state[N];
int      temp[N];
double   inf[T];
double   avedeg[T];
int      deg[N];
int      inftimes[N];

//FILE  *fp1=fopen("edge_la4900.txt","r");
FILE  *fp1=fopen("edge_ba,z=16,10000.txt","r");
FILE  *fp2=fopen("infect.txt","w");
FILE  *fp3=fopen("speed.txt","w");
FILE  *fp4=fopen("domain.txt","w");
FILE  *fp5=fopen("degree_ave.txt","w");
FILE  *fp6=fopen("infect_deg-dis.txt","w");
FILE  *fp7=fopen("inf_times.txt","w");

void input(void)
{
	int a,b;
	int i,j;
	int num;
	for(i=0;i<N;i++)
	{
		deg[i]=0;
		for(j=0;j<2000;j++)
		{
			node[i][j]=0;
		}
	}
	while((fscanf(fp1,"%d %d",&a,&b))==2)
	{
		node[a][deg[a]]=b;
		node[b][deg[b]]=a;
		deg[a]++;
		deg[b]++;
	}
	


}


void initial(void)
{
	int i,num0,temp2,num;
	for(i=0;i<T;i++)
	{
		inf[i]=0;
		avedeg[i]=0;
	}
	for(i=0;i<N;i++)
	{
		state[i]=temp[i]=0;
	}
	num=0;
	while(num<N0)
	{
		temp2=rand()%N;
		if(state[temp2]==0)
		{
			state[temp2]=temp[temp2]=1;
			num++;
		}
	}


}

void infection(int t)
{
	int i,j;
	int ti=0;
	double frand;
	for(i=0;i<N;i++)
	{
		state[i]=temp[i];
	}
	for(i=0;i<N;i++)
	{
		temp[i]=0;
	}
	
    for(i=0;i<N;i++)
	{
		if(state[i]==1)
		{
			for(j=1;j<=node[i][0];j++)
			{
				
    				frand=(double)rand()/RAND_MAX;
    				if(frand<P)
					{
						temp[j]=1;
						inftimes[j]++;
						ti++;
						avedeg[t]+=deg[j];
					}
				
			}
		}
	}
	
	avedeg[t]/=ti;
	for(i=0;i<N;i++)
	{
		state[i]=0;
	}
}

void  tongji(int t)
{
	int i;
	for(i=0;i<N;i++)
	{
		if(temp[i]==1)
		{
			inf[t]++;
		}
	}
	inf[t]/=N;
}

void  output(void)
{
	int i;
	for(i=1;i<T;i++)
	{
		fprintf(fp2,"%lf\n",inf[i]);
//		fprintf(fp3,"%lf\n",inf[i]-inf[i-1]);
//		fprintf(fp5,"%lf\n",avedeg[i]);
	}
//	fprintf(fp4,"%lf\n",inf[T-1]);
	for(i=0;i<N;i++)
	{
		if(temp[i]==1){}
//			fprintf(fp6,"%d\n",deg[i]);
//		fprintf(fp7,"%d %d\n",deg[i],inftimes[i]);
	}
}

int main(void)
{
	int i,j;
	srand((unsigned)time(NULL));
    input();
	for(i=0;i<N;i++)
	{
		inftimes[i]=0;
	}
	for(j=0;j<AG;j++)
	{
        printf("%d\n",j);
	initial();
	for(i=0;i<T;i++)
	{
		if(i%10==0)
			printf("%d\n",i);
		infection(i);
		tongji(i);
	}


		output();

	}
	return 0;
}
