set DIRE
set w .complexgui
catch {destroy $w}
toplevel $w
wm title $w "ComplexNetwork_ToolBox"  

wm iconname $w "complexgui"
frame $w.top -borderwidth 10
pack $w.top -side top -fill x

set statusbar " "
frame $w.statusBar
set lab1 [label $w.statusBar.label -textvariable statusbar -relief sunken -bd 1\
	-font "Helvetica 10" -anchor w]
pack $w.statusBar.label -side left -padx 2 -expand yes -fill both
pack $w.statusBar -side bottom -fill x -pady 2

button $w.top.file -text "Open" -underline 1  -command OpnFle
button $w.top.sve -text "Save" -underline 1 -command SveFle
button $w.top.quit -text "Quit" -underline 1 -command exit
button $w.top.about -text "About" -underline 1 -command About
button $w.top.demo -text "Demo" -underline 1 -command Demo
button $w.top.help -text "Help" -underline 1 -command Hlp
pack $w.top.file $w.top.sve $w.top.quit $w.top.demo $w.top.help $w.top.about  -side left -padx 10 




#image create bitmap flagup \
#	-file [file join $tk_library demos images flagup.bmp] \
#	-maskfile [file join $tk_library demos images flagup.bmp]
#image create bitmap flagdown \
#	-file [file join $tk_library demos images flagdown.bmp] \
#	-maskfile [file join $tk_library demos images flagdown.bmp]
#frame $w.frame -borderwidth 10
#pack $w.frame -side top

#checkbutton $w.frame.b1 -image flagdown -selectimage flagup \
	-indicatoron 0
#$w.frame.b1 configure -selectcolor [$w.frame.b1 cget -background]
#checkbutton $w.frame.b2 \
	-bitmap @[file join $tk_library demos images letters.bmp] \
	-indicatoron 0 -selectcolor SeaGreen1
#frame $w.frame.left
#pack $w.frame.left $w.frame.b1 $w.frame.b2 -side left -expand yes -padx 5m

#radiobutton $w.frame.left.b3 \
#	-bitmap @[file join $tk_library demos images letters.bmp] \
#	-variable letters -value full
#radiobutton $w.frame.left.b4 \
#	-bitmap @[file join $tk_library demos images noletter.bmp] \
#	-variable letters -value empty
#pack $w.frame.left.b3 $w.frame.left.b4 -side top -expand yes

frame $w.top1 -borderwidth 5
label $w.top1.lab -text "File:" -padx 0
set ls [entry $w.top1.ls  -width 20 -relief sunken]
button $w.top1.browse -text "Browse..." -command OpnFle
pack $w.top1.lab -side left
pack $w.top1.ls -side left -fill x  -expand yes 
pack $w.top1.browse -side left 
pack $w.top1 -side top -fill x -padx 1c -pady 3
focus $w.top1.ls

frame $w.b
button $w.b.pre -text "Preview" -command Prev
button $w.b.stpov -text "Step Over" -command Stepov
set but [button $w.b.run -text "Run" -command Run]
bind $w.b.run <Return> Run
pack $w.b.pre  -side left -padx 5 -pady 5
pack $w.b.stpov -side left -padx 5 -pady 5
pack $w.b.run -side left -padx 5 -pady 5
pack $w.b -side top -fill x 


#frame $w.t
#set log [text $w.t.log -width 80 -height 10 -font "Helvetica 10"\
	-borderwidth 2 -relief raised -setgrid true\
        -yscrollcommand {$w.t.scroll set}]
#scrollbar $w.t.scroll -command {$w.t.log yview}
#pack $w.t.scroll -side left -fill both -expand false  
#pack $w.t.log -side left -fill both -expand true
#pack $w.t -side top -fill both -expand true

frame $w.frame -borderwidth .5c
pack $w.frame -side top -expand yes -fill x

scrollbar $w.frame.scroll -command "$w.frame.list yview"
listbox $w.frame.list -yscroll "$w.frame.scroll set" -setgrid 1 -height 10
pack $w.frame.scroll -side right -fill y
pack $w.frame.list -side left -expand 1 -fill both

$w.frame.list insert 0 "ba 8 6 100" "sis 0.2 100"


frame $w.d
button $w.d.addt -text "Add" -command Add 
button $w.d.del -text "Delete" -command Del
pack $w.d.addt $w.d.del -side left -padx 10 -pady 3
pack $w.d -side top

labelframe $w.resl -text "DataResult:" 
label $w.resl.l  -font "Helvetica 10" -text "average degree: 9.778\nthe number of infected nodes:41"
pack $w.resl.l  -side top
pack $w.resl -side top -fill both -expand yes

#catch {image delete image2a}
#image create photo image2a -file [file join $tk_library demos images face.bmp]
#labelframe $w.image -text "PictureResult:"
#label $w.image.image -image image2a -bd 1 -relief sunken
#loadImage $image2a "e:\\figure2.jpg" %x%y
#pack $w.image.image -padx 2m -pady 2m
#pack $w.image -side right


proc Run { } {
	global DIRE lab1
	$lab1 config -text "Busy"
#	ScilabEval "exec('$DIRE/src/ba.sce');"
}

proc Stop {} {
	global input but
	catch {close $input}
	$but config -text "Run it" -command Run
}
proc OpnFle {} {
	global DIRE log ls Filename
        set fname tk_getOpenFile
	#ScilabEval "tk_getfile()"
	#$log insert end $Filename
	#$set in [open "$DIRW+/$fname"]
	#$log insert end [read $in]
	#close $in
	#set dir [tk_chooseDirectory -initialdir $DIRE -parent $w -mustexist 1]
        #if {[string length $dir] != 0} {
	#set DIRE $dir
	#loadDir $w
        #}
	#ScilabEval "exec('$DIRE/src/opfile.sce');"
	#$ls -text $Filename
	#if [catch {open "$Filename" input}]{
	#	$log insert end $input\n
	#} else {
	#	gets $input line
	#	$log insert end $line\n
	#	$log see end
	#}
	#set in [open  $Filename] 
       	#$log insert end [read $in]
	#close $in
#	update
	#unset Filename
}

proc SveFle {} {
	global DIRE
	ScilabEval "exec('$DIRE/src/svefle.sce');"
}
proc About {} {
	global DIRE
	ScilabEval "exec('$DIRE/src/about.sce');"
}
proc Browse {} {
}

proc Add {} {
	$log insert \n
}
proc Del {} {
}

proc loadDir w {
    global DIRE

    $w.f.list delete 0 end
    foreach i [lsort [glob -directory $DIRE *]] {
	$w.f.list insert end [file tail $i]
    }
}





