//Calculate the Cluster 
//By WuBo

//////////////////////////////////////////////
//Calculate the cluster coefficient of node i in g
/////////////////////////////////////////////

function cluster=cluster_measure(i,g)
nei=neighbors(i,g);
[x,y]=size(nei);
e=0;
for z=1:y-1
  t=neighbors(nei(z),g)
  [a,b]=size(t);
    for zz=1:b
     if(nei(z+1)==t(zz))
        e=e+1;
     end //if  
    end  //for
end //for 

k=nodes_degrees(g);

if k>1 then
cluster=2*e/((k(i)-1)*k(i));
else cluster=0;
end

endfunction

/////////////////////////////////////////////////////
//Calulate the average cluster coefficient in g
////////////////////////////////////////////////////

function cluster_ba=aver_cluster(g)
cluster=0;
winId=waitbar('Calculating...');
for i=1:g('node_number')
waitbar(round(i/g('node_number')*100)/100,winId);
cluster=cluster+cluster_measure(i,g);
end //for
cluster_ba=cluster/g('node_number');
winclose(winId);
endfunction //end function






