//Graph Model 
//By WuBo 
//Revised by 06.7.23



//ȶ
function r=assort_c(a,b,m,g)
i=length(a);
D=nodes_degrees(g);
s0=0;
s1=0;
s2=0;
winId=waitbar('Calculate the assortativity coefficient...');
for j=1:i
  waitbar(round(j/i*100)/100,winId);
    s0=s0+D(a(j))*D(b(j));  //sum(jk)
    s1=s1+D(a(j))+D(b(j));  //sum(j+k)
    s2=s2+D(a(j))^2+D(b(j))^2; //sum(j^2+k^2)
  end
winclose(winId); 
r=(s0/m-(s1/2/m)^2)/(s2/2/m-(s1/2/m)^2);
endfunction


//initial graph
//Random function
//////////////////////////////////////////////////////////////////////
//the normal BA model rule (add the attractness,exponent and fittness)
//////////////////////////////////////////////////////////////////////
function node=node_select(g)
    BA_degree=nodes_degrees(g);
    x(1)=BA_degree(1);
    for i=2:g1('node_number')
      x(i)=BA_degree(i)+x(i-1);
    end
   //normal 
    for i=1:g('node_number')
    y(i)=x(i)/x(g('node_number'))
    end
    //chose the selected node
    nrand=rand();
     for i=1:(g('node_number')-1)
        if (nrand>=y(i) & nrand<y(i+1))
         node=i;
        return; 
        end
     end
     node=g('node_number')-1;
endfunction


////////////////////////////////////////////////////
//Create the BA model with exponent r=3/////////
//M0: the initial node, here we create a complete graph at first//
//M:  Add M link when a node is added into the graph
//N:  The evolutional time step (not include M0)
///////////////////////////////////////////////////
function g=createBA(M0,M,N)
ii_temp=1;
for ii=1:M0-1
  for jj=ii+1:M0
     ta(1,ii_temp)=ii;
     he(1,ii_temp)=jj;
     ii_temp=ii_temp+1;
  end
end 

g1=make_graph('BA',0,M0,ta,he);

for ii=1:M0
eg=2*%pi/M0;
g1('node_x')(1,ii)=300+100*sin(ii*eg);
g1('node_y')(1,ii)=300-100*cos(ii*eg);
end

//A simple progressbar
winId=waitbar('Creating the BA model...');


for i=1:N
waitbar(round(i/N*100)/100,winId);
eg=2*%pi/N;
g1=add_node(g1,[300+200*sin(eg*i),300-200*cos(eg*i)]);
n=g1('node_number');

//Mÿӵı
  m=1;
  while m<=M
  //node=node_select(g1);
  node=node_select(g1);
  node_nei=neighbors(node,g1);
  flag=0;
  
    [x,y]=size(node_nei);  //ж
    for mm=1:y
      if n==node_nei(mm) | n==node
       flag=1;
      end
    end
   
   if flag==0
   g1=add_edge(n,node,g1);
   g1('edge_color')=int(rand(1:edge_number(g1))*16);
   m=m+1;
   end
 end //while
end //for
g=g1;
winclose(winId);
g('node_diam')=8*ones(1,g.node_number);
//x_message('Display the BA graph');
endfunction


/////////////////////////////////////////////////////
//Create ER Model
function g=createER(p,N)
ta=[1];
he=[2];
g1=make_graph('ER',0,2,ta,he);
g1('node_x')=[100 200];
g1('node_y')=[200 300];
//show_graph(g1,1);

//initial the graph
//Create the graph
for i=3:N
eg=2*%pi/N;
g1=add_node(g1,[round(300+200*sin(eg*i)) round(300-200*cos(eg*i))]);
end



winId=waitbar('Creating the ER model...');
//index=1;
for i=1:N-1
waitbar(round(i/N*100)/100,winId);
for j=i+1:N
if(rand()<p)
//if(rand()<p & i<>1 & j<>2)
g1=add_edge(i,j,g1); 
//if(i==1&j==2)
//g1=delete_arcs([1 2],g1);
//end
g1('edge_color')=int(rand(1:edge_number(g1))*16);
end //if
end  //for i
end //for j
   



winclose(winId);
g=g1;
x_message('Display the ER graph');
endfunction

//////////////////////////////////////////////////////
//Creat BBV model








