//Graph Model 
//By WuBo 
//Revised by 06.7.23


//initial graph
//Random function

function node=node_select(g)
    BA_degree=nodes_degrees(g);
    x(1)=BA_degree(1);
    for i=2:g1('node_number')
      x(i)=BA_degree(i)+x(i-1);
    end
   //normal 
    for i=1:g('node_number')
    y(i)=x(i)/x(g('node_number'))
    end
    nrand=rand();
     for i=1:(g('node_number')-1)
        if (nrand>=y(i) & nrand<y(i+1))
         node=i;
         return; 
        end
     end
     node=g('node_number')-1;
endfunction

////////////////////////////////////////////////////
//Create the BA model with exponent r=3/////////
//M0: the initial node, here we create a complete graph at first//
//M:  Add M link when a node is added into the graph
//N:  The evolutional time step (not include M0)
///////////////////////////////////////////////////
function g=createba(M0,M,N)
ii_temp=1;
for ii=1:M0-1
  for jj=ii+1:M0
     ta(1,ii_temp)=ii;
     he(1,ii_temp)=jj;
     ii_temp=ii_temp+1;
  end
end 

g1=make_graph('BA',0,M0,ta,he);

//A simple progressbar
winId=waitbar('Creating the BA model...');
for i=1:N
waitbar(round(i/N*100)/100,winId);
//eg=2*%pi/N;
//g1=add_node(g1,[300+200*sin(eg*i),300-200*cos(eg*i)]);
g1=add_node(g1);
n=g1('node_number');

//Mÿӵı
  m=1;
  while m<=M
  //node=node_select(g1);
  node=node_select(g1);
  node_nei=neighbors(node,g1);
  flag=0;
  
    [x,y]=size(node_nei);  //ж
    for mm=1:y
      if n==node_nei(mm) | n==node
       flag=1;
      end
    end
   
   if flag==0
   g1=add_edge(n,node,g1);
//   g1('edge_color')=int(rand(1:edge_number(g1))*16);
   m=m+1;
   end
 end //while
end //for
g=g1;
winclose(winId);
//g('node_diam')=8*ones(1,g.node_number);
//x_message('Display the BA graph');
endfunction







