//Preview function calculation
//Create by wubo
//06.8.26

//Clustering coefficient
///////////////////////////////////////////////////////
//Ws small world ϵ///
///////////////////////////////////////////////////////

function c=ws_c(k,p)
c=3*(k-2)*(1-p)^3/(4*(k-1));
endfunction

/////////////////////////////////////////////////////
//NW small world ϵ
/////////////////////////////////////////////////////
function c=nw_c(k,p)
c=3*(k-2)/(4*(k-1)+4*k*p*(p+2));
endfunction

//////////////////////////////////////////////////
//WS small world ƽ·
//Based on the Newman's mean-field theroy
//But the result is rough, until now (08/24/06 :))
//The result is not a accurate analysis solution 
//////////////////////////////////////////////////

function p=ws_l(k,p,n)
a=2*n/k;
u=n*k*p/2;
fu=1/(sqrt(u^2+2*u))*atan(sqrt((x/(x+1))));
p=a*fu;
endfunction

//////////////////////////////////////////////////////
//BA network ƽ·, ֻǸȵĹϵ,ҶӦr=3
/////////////////////////////////////////////////////
function p=ba_l(n)
p=log(n)/log(log(n));
endfunction

//////////////////////////////////////////////////////////
//BA network ľϵ
//m: ÿμӵı
//t: Ĳ
//////////////////////////////////////////////////////////
function c=ba_c(m,t)
a=m^2*(m+1)^2/4/(m-1);
b=log((m+1)/m)-1/(m+1);
d=(log(t))^2/t;
c=a*b*d;
endfunction


//////////////////////////////////////////////////////////
//Epidemic process ٽֵ (SISSIRSȾģ)
//////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////
//Homogeneous model ٽֵ (WS model or ER model)
//epidemic transition: 
/////////////////////////////////////////////////////////
function et=homo_et(g)
et=1/kba_para(g);
endfunction

///////////////////////////////////////////////
//Heterogeneous network//
//////////////////////////////////////////////
function et=heter_et(g)
et=kba_para(g)/kfang_para(g);
endfunction









